//**********************************
#property indicator_chart_window
#property  indicator_buffers 2
#property indicator_color1 LightSkyBlue
#property indicator_color2 Pink
#property indicator_width1 2
#property indicator_width2 2
//==================================
extern string  TimeFrame   = "Current time frame";
extern int p=6;
extern int s=3;
extern int cb=300;
//==================================
double fx[],fxL[],za[];
double z1,z2,ki;
int fs;
string indicatorFileName;
bool   returnBars;
int    timeFrame;
//**********************************
int init()
{
   IndicatorBuffers(3);
   //-------------------
   SetIndexBuffer(0,fx);  SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,fxL); SetIndexEmptyValue(1,0.0);
   //-------------------
   SetIndexBuffer(2,za); 
   //--------------------------
   ki=2.0/(p+1);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   //--------------------------
   return(0);
}
//***************************************************************************
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) {  fx[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                      fx[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",p,s,cb,0,y);
                      fxL[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",p,s,cb,1,y);
                      
               }
               return(0);
            }

   SetIndexDrawBegin(0,Bars-cb);
   SetIndexDrawBegin(1,Bars-cb);
   for (i=cb; i>=0; i--) {fx[i]=Close[i];}
   
   for (int m=0; m<=s; m++)
   {
      z1=fx[0];
      for (i=0; i<=cb; i++) {z1=z1+(fx[i]-z1)*ki; za[i]=z1;}
      
      z2=fx[cb];
      for (i=cb; i>=0; i--) {z2=z2+(fx[i]-z2)*ki; fx[i]=(za[i]+z2)/2;}
   } 
   
   fs=0; 
   for (i=cb; i>=0; i--) 
   {
      if (fx[i]>fx[i+1]) fs=1;
      if (fx[i]<fx[i+1]) {if (fs==1) fxL[i+1]=fx[i+1]; fs=2;}
      if (fs==2) fxL[i]=fx[i]; else fxL[i]=0.0;
   }
   
   return(0);
}
//************************************************************
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   ss = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(ss, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     ss = StringSetChar(ss, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     ss = StringSetChar(ss, length, tchar + 224);
   }
   return(ss);
}



